VERSION 5.00
Begin VB.Form frmListSysColors 
   Caption         =   "Override ListBox Example"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstSysColors 
      Height          =   2760
      Left            =   120
      Style           =   1  'Checkbox
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
End
Attribute VB_Name = "frmListSysColors"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'APIs For Getting & Setting System Colours
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SetSysColors Lib "user32" (ByVal nChanges As Long, lpSysColor As Long, lpColorValues As Long) As Long

'Enum For System Colours
Public Enum enSystemColours
  COLOR_ACTIVEBORDER = 10
  COLOR_ACTIVECAPTION = 2
  COLOR_APPWORKSPACE = 12
  COLOR_BACKGROUND = 1
  COLOR_BTNFACE = 15
  COLOR_BTNHIGHLIGHT = 20
  COLOR_BTNSHADOW = 16
  COLOR_BTNTEXT = 18
  COLOR_CAPTIONTEXT = 9
  COLOR_GRAYTEXT = 17
  COLOR_HIGHLIGHT = 13
  COLOR_HIGHLIGHTTEXT = 14
  COLOR_INACTIVEBORDER = 11
  COLOR_INACTIVECAPTION = 3
  COLOR_INACTIVECAPTIONTEXT = 19
  COLOR_MENU = 4
  COLOR_MENUTEXT = 7
  COLOR_SCROLLBAR = 0
  COLOR_WINDOW = 5
  COLOR_WINDOWFRAME = 6
  COLOR_WINDOWTEXT = 8
End Enum

'Property For Colours
Public Property Get SystemColours(ColourID As enSystemColours) As Long
  SystemColours = GetSysColor(ColourID)
End Property

'Sub to Load & Apply Colours To ListBox
Private Sub LoadColours(Colour As Long, ColName As String)

lstSysColors.AddItem ColName
lstSysColors.itemData(lstSysColors.NewIndex) = Colour
End Sub

'Load & Apply Colours, Before Form Is Shown
Private Sub Form_Initialize()
    'Call The LoadColours Sub To Apply The System Colours
    'Via The System COlour's ID And "Known" Name
    Call LoadColours(Me.SystemColours(COLOR_ACTIVECAPTION), "Active Caption")
    Call LoadColours(Me.SystemColours(COLOR_APPWORKSPACE), "Application Workspace")
    Call LoadColours(Me.SystemColours(COLOR_BACKGROUND), "Background")
    Call LoadColours(Me.SystemColours(COLOR_BTNFACE), "Button Face")
    Call LoadColours(Me.SystemColours(COLOR_BTNHIGHLIGHT), "Button Highlight")
    Call LoadColours(Me.SystemColours(COLOR_BTNSHADOW), "Button Shadow")
    Call LoadColours(Me.SystemColours(COLOR_BTNTEXT), "Button Text")
    Call LoadColours(Me.SystemColours(COLOR_CAPTIONTEXT), "Caption Text")
    Call LoadColours(Me.SystemColours(COLOR_GRAYTEXT), "Grayed Text")
    Call LoadColours(Me.SystemColours(COLOR_HIGHLIGHT), "Highlight")
    Call LoadColours(Me.SystemColours(COLOR_HIGHLIGHTTEXT), "Highlighted Text")
    Call LoadColours(Me.SystemColours(COLOR_INACTIVEBORDER), "Inactive Border")
    Call LoadColours(Me.SystemColours(COLOR_INACTIVECAPTION), "Inactive Caption")
    Call LoadColours(Me.SystemColours(COLOR_INACTIVECAPTIONTEXT), "Inactive Caption Text")
    Call LoadColours(Me.SystemColours(COLOR_MENU), "Menu")
    Call LoadColours(Me.SystemColours(COLOR_MENUTEXT), "Menu Text")
    Call LoadColours(Me.SystemColours(COLOR_SCROLLBAR), "ScrollBar")
    Call LoadColours(Me.SystemColours(COLOR_WINDOW), "Window")
    Call LoadColours(Me.SystemColours(COLOR_WINDOWFRAME), "Window Frame")
    Call LoadColours(Me.SystemColours(COLOR_WINDOWTEXT), "Window Text")
    

End Sub

'Set the ListBox Style Property To 1 - CheckBox
'In Properties Window FIRST!!!!

Private Sub Form_Load()

    'Subclass Form To Recieve All Listbox Messages
    lPrevWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf OverrideList)

End Sub

Private Sub Form_Unload(Cancel As Integer)

    'Release SubClassing
    Call SetWindowLong(hwnd, GWL_WNDPROC, lPrevWndProc)
    
End Sub
